# This file is a template, and might need editing before it works on your project.
# You can copy and paste this template into a new `.gitlab-ci.yml` file.    
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at :
# https://docs.gitlab.com/ee/development/cicd/templates.html    
# This specific template is located at:    
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Nodejs.gitlab-ci.yml

# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/node/tags/ 
image: registry.gitlab.com/gitlab4ibmi/dockerrunneribmi:58664b6716cb146d2f032c1c65ee7d18d8f69e58


# Pick zero or more services to be used on all builds.
# Only needed when using a docker container to run your tests in.
# Check out: https://docs.gitlab.com/ee/ci/services/index.html
services:
stages:
  - test
  - deploy
# This folder is cached between builds
# https://docs.gitlab.com/ee/ci/yaml/index.html#cache
cache:
  paths:
    - node_modules/

test_job:
  stage: test
  environment: DEV
  script:
    - echo "Running tests"
    - echo $DATABASE_URL
  variables:
    DATABASE_URL: $DEV_DATABASE_URL   

test_ibmci:
  stage: test
  tags:
    - ibmi
  environment: DEV
  script:
    # - npm i -g @ibm/sourceorbit
    # - npm i -g @ibm/ibmi-ci
    - ici --cmd "rm -rf './testgitlab'"
    - ici --cmd "system 'dspsyssts'"
    - env
  variables:
    IBMI_HOST: $IBMI_HOST
    IBMI_PASSWORD: $IBMI_PASSWORD
    IBMI_SSH_PORT: $IBMI_SSHPORT
    IBMI_USER: $IBMI_USER

    

deploy_job:
  stage: deploy
  environment: PROD
  script:
    - echo "Deploying to production"
    - echo $PROD_DATABASE_URL
    - echo $PRODUCTION_DEPLOY_KEY

  only:
    - main
  variables:
    DATABASE_URL: $PROD_DATABASE_URL
    DEPLOY_KEY: $PRODUCTION_DEPLOY_KEY

